# =============================================================================== #
# xxx <>>> ES/PYTHON IMPORTS xxxxxxxxxx #
from __future__ import with_statement
import es, popuplib, playerlib, os
import psyco
psyco.full()
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# xxxxxxxxxx # SAM IMPORTS # xxxxxxxxxx #
func   = es.import_addon('sam/functions')
core   = es.import_addon('sam/core')
admins = es.import_addon('sam/core/admins')

# x # VARIABLES/DICTIONARIES/LISTS # xx #
db       = 'sam_addons'
folder   = 'sam/addons/'
dbfolder = 'cstrike/cfg/sam_config/databases/es_%s_db.txt' % db
infos    = ['name','version','description','basename','status']
addons   = []
TEMP     = {}
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# =============================================================================== #
# === <<<> LOAD <>>> ============================================================ #
# =============================================================================== #
def load():

	# LOAD ADDONS
	es.load('sam/addons')
	for x in getAddons():
		try:
			if int(get(x,'status')) == 1: es.load('sam/addons/%s' % x)
		except: func.log(func.langCore('MODULE_ERROR',{'module':x.upper()}),func.errortag)

# =============================================================================== #
# === <<<> UNLOAD <>>> ========================================================== #
# =============================================================================== #
def unload():

	# UNLOAD ADDONS
	es.unload('sam/addons')
	for x in getAddons(): es.unload('sam/addons/%s' % x)

	# POPUPS
	func.popupDelete('addonspage')
	func.popupDelete('monitor')

# =============================================================================== #
# === <<<> MAIN BLOCKS <>>> ===================================================== #
# =============================================================================== #
def page(ID, SEND=True):
	func.popupDelete('addonspage')
	popup = func.easymenu(popuplib.easymenu('addonspage', None, monitor),'home')
	popup.settitle(func.header(func.langCommon('TITLE_MONITOR')))
	for addon in getAddons():
		try: popup.addoption(addon, get(addon,'name'))
		except: func.hudhint(ID, func.langCore('MODULE_ERROR',{'module':addon.upper()}),func.errortag)
	if SEND: popup.send(ID)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def monitor(ID, ADDON, POPUP):
	page(ID, False)
	popup = func.simplemenu('monitor','addonspage',False)
	popup.addline(func.header(func.langCommon('TITLE_MONITOR')))
	popup.addline(func.line)
	popup.addline('%s: %s' % (func.langCommon('NAME'),get(ADDON,'name')))
	popup.addline('%s: %s' % (func.langCommon('VERSION'),get(ADDON,'version')))
	popup.addline('%s:\n- %s' % (func.langCommon('DESCRIPTION'),get(ADDON,'description')))
	popup.addline(func.line)
	if int(get(ADDON,'status')) == 0: popup.addline('->1. %s: %s : [ %s ]' % (func.langCommon('STATUS').upper(),func.langCommon('ON').upper(),func.langCommon('OFF').upper()))
	else: popup.addline('->1. %s: [ %s ] : %s' % (func.langCommon('STATUS').upper(),func.langCommon('ON').upper(),func.langCommon('OFF').upper()))
	popup.addline(func.line)
	popup.addline('->0. %s' % func.langCommon('CANCEL'))
	popup.menuselect = monitorChoice
	popup.send(ID)
	TEMP[ID] = ADDON

# ------------------------------------------------------------------------------- #
def monitorChoice(ID, CHOICE, POPUP):
	ADDON = TEMP[ID]
	if CHOICE == 1:
		try:
			path  = func.sampath+'/addons/%s/info.txt' % ADDON
			temp  = {}
			f     = open(path,'r')
			for line in f.readlines():
				for x in infos:
					if line.startswith(x): temp[x] = str(line.replace('%s='%x,'').strip('\n'))
			f.close()
			os.remove(path)
			f = open(path,'w')
			f.write('### DONT CHANGE THIS FILE ###\n')
			try:
				for x in temp:
					if not x == 'status': f.write('%s=%s\n' % (x, temp[x]))
				if int(temp['status']) == 0:
					f.write('status=1')
					es.load('sam/addons/%s' % (ADDON))
				else:
					f.write('status=0')
					es.unload('sam/addons/%s' % (ADDON))
			except: func.hudhint(ID, func.langCore('MODULE_ERROR',{'module':ADDON.upper()}),func.errortag)
			f.close()
		except: func.hudhint(ID, func.langCore('INTERNAL_ERROR'),func.errortag)
	if not CHOICE == 10: monitor(ID,ADDON,None)
	else: page(ID)
	core.home(ID, False)

# =============================================================================== #
# === <<<> FUNCTIONS <>>> ======================================================= #
# =============================================================================== #
def getAddons():
	dir = func.sampath+'/addons/'
	return [x for x in os.listdir(dir) if os.path.isdir(dir + x) == True]

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def get(ADDON,KEY,R=False):
	f = open(func.sampath+'/addons/%s/info.txt' % ADDON)
	for line in f.readlines():
		if line.startswith(KEY): R = line.replace('%s='%KEY,'').strip('\n')
	return R

# =============================================================================== #
# === <<<> ADDONS CONFIGURATION SYSTEM <>>> ===================================== #
# =============================================================================== #
def cfg(ADDON, TOKENS):
	path = func.addonscfg + ADDON + '.cfg'
	if not os.path.isfile(path): # GLOBAL CONFIG FILE
		cfg = open(path,'w')
		cfg.write('// %s\n' % ('-' * 50))
		cfg.write('//  Source Admin Menu | %s Configuration File\n' % TOKENS['addon'])
		cfg.write('// %s\n' % ('-' * 50))
		cfg.write('//  * Do not restart the server after changing the commands!\n')
		cfg.write('//  * Any changes will take effect within 10 seconds after you save this file.\n')
		cfg.write('// %s\n \n' % ('-' * 50))
		del TOKENS['addon']
		for cmd in TOKENS:
			cfg.write('// %s\n' % TOKENS[cmd]['description'])
			cfg.write('//\n')
			cfg.write('// Default: %s\n' % TOKENS[cmd]['value'])
			cfg.write('%s %s\n \n' % (cmd,TOKENS[cmd]['value']))
		cfg.close()

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #