# =============================================================================== #
# xxx <>>> ES/PYTHON IMPORTS xxxxxxxxxx #
import es
import popuplib
import playerlib
import gamethread
import time
import os
import psyco
psyco.full()
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# xxxxxxxxxx # SAM IMPORTS # xxxxxxxxxx #
func     = es.import_addon('sam/functions')
core     = es.import_addon('sam/core')
pcontrol = es.import_addon('sam/core/pcontrol')
admins   = es.import_addon('sam/core/admins')
groups   = es.import_addon('sam/core/admins/groups')

# x # VARIABLES/DICTIONARIES/LISTS # xx #

db     = 'sam_mutes'
dbpath = 'cstrike/cfg/sam_config/databases/es_%s_db.txt' % db
times  = {'5m':300,'30m':1800,'1h':3600,'3h':10800,'1d':86400,'3d':259200,'1w':604800,'1m':2592000,'1':31536000}
sort   = ('perm','5m','30m','1h','3h','1d','3d','1w','1mo','1y')
muted  = []

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# =============================================================================== #
# === <<<> LOAD <>>> ============================================================ #
# =============================================================================== #
def load():

	# DATABASE
	if existsDB(): es.keygroupload(db, func.dbfolder)

	# FILTERS
	es.addons.registerSayFilter(ChatMuteFilter)
	es.addons.registerTickListener(MuteFilter)

# =============================================================================== #
# === <<<> UNLOAD <>>> ========================================================== #
# =============================================================================== #
def unload():

	# DATABASE
	es.keygroupdelete(db)

	# FILTERS
	es.addons.unregisterSayFilter(ChatMuteFilter)
	es.addons.unregisterTickListener(MuteFilter)

	# POPUPS
	func.popupDelete('mutePlist')
	func.popupDelete('muteTime')

# =============================================================================== #
# === <<<> MAIN BLOCKS <>>> ===================================================== #
# =============================================================================== #
def page(ID):
	func.popupDelete('mutePlist')
	popup = func.easymenu(popuplib.easymenu('mutePlist', None, listChoice),'pcontrol')
	popup.settitle(func.header(func.langPcontrol('MUTE')))
	for x in playerlib.getPlayerList('#human'):
		if isMuted(x.steamid): popup.addoption(x, '%s [%s]' % (x.name,func.langPcontrol(es.keygetvalue(db,x.steamid,'length'))))
		else: popup.addoption(x, x.name)
	popup.send(ID)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def listChoice(ID, TARGET, POPUP, SEND=True):
	if admins.immunity(playerlib.getPlayer(ID),TARGET):
		if not isMuted(TARGET.steamid):
			func.popupDelete('muteTime')
			popup = func.easymenu(popuplib.easymenu('muteTime', None, mute),'mutePlist')
			popup.settitle(func.header(func.langPcontrol('MUTE')))
			for x in sort: popup.addoption([TARGET,x], func.langPcontrol(x.upper()))
			popup.send(ID)
		else:
			es.keydelete(db, TARGET.steamid)
			es.keygroupsave(db, func.dbfolder)
			if TARGET in muted: muted.remove(es.getuserid(TARGET))
			func.tell('#all', func.langPcontrol('TARGET_UNMUTED',{'target':TARGET.name}), '#greenMUTE')
			page(ID)
	else: page(ID)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def mute(ID, TOKENS, POPUP, SEND=True):
	target = TOKENS[0]
	if es.exists('keygroup', db) == 0: es.keygroupcreate(db)
	if es.exists('key', db, target.steamid) == 0: es.keycreate(db, target.steamid)
	es.keysetvalue(db, target.steamid, 'name', target.name)
	es.keysetvalue(db, target.steamid, 'length', TOKENS[1].upper())
	if TOKENS[1] == 'perm': es.keysetvalue(db, target.steamid, 'muteid', 'perm')
	else: es.keysetvalue(db, target.steamid, 'muteid', int(time.time()) + times[TOKENS[1]])
	if not target in muted: muted.append(target)
	es.keygroupsave(db, func.dbfolder)
	func.tell('#all', func.langPcontrol('TARGET_MUTED',{'target':target.name,'length':func.langPcontrol(TOKENS[1].upper())}), '#greenMUTE')
	if SEND: page(ID)

# =============================================================================== #
# === <<<> FUNCTIONS <>>> ======================================================= #
# =============================================================================== #
def isMuted(TARGET, R=False):
	if existsDB() and es.exists('key', db, TARGET):
		muteid = es.keygetvalue(db, TARGET, 'muteid')
		if muteid == 'perm': R = True
		elif int(muteid) > int(time.time()): R = True
		else:
			es.keydelete(db, TARGET)
			es.keygroupsave(db, func.dbfolder)
			if es.exists('userid', es.getuserid(TARGET)): muted.remove(es.getuserid(TARGET))
	return R

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def existsDB():
	if os.path.isfile(dbpath): return True
	else: return False

# =============================================================================== #
# === <<<> CMD BLOCKS <>>> ====================================================== #
# =============================================================================== #

# =============================================================================== #
# === <<<> EVENTS <>>> ========================================================== #
# =============================================================================== #
def player_activate(EV):
	if isMuted(EV['es_steamid']): muted.append(EV['userid'])

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def player_disconnect(EV):
	if EV['userid'] in muted: muted.remove(EV['userid'])

# =============================================================================== #
# === <<<> FILTERS AND OTHERS <>>> ============================================== #
# =============================================================================== #
def ChatMuteFilter(ID, TEXT, TEAM):
	if isMuted(es.getplayersteamid(ID)): return(0,0,0)
	else: return(ID,TEXT,TEAM)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def MuteFilter():
	for x in es.getUseridList():
		for target in muted:
			if isMuted(es.getplayersteamid(target)): es.voicechat('nolisten', x, target)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #